#pragma once

// AFAP includes.
#include "components/worker_node/src/transaction_manager.hpp"
#include "UvrTypes.hpp"

namespace apigw
{

    constexpr int verifyCallsManagerId = 1;
    constexpr int digestsManagerId = 2;

    namespace transaction
    {

        class data : public ::transaction::base_data
        {
        public:
            Uvr::UserId_t userId;
            Uvr::OperatorId_t idSrc;
            Uvr::OctetStringPtr callingNumber;
            Uvr::OctetStringPtr calledNumber;
            Uvr::OctetStringPtr originalCalledNumber;
            Uvr::OctetStringPtr genericNumber;
            Uvr::CallId_t callId;

            data() = default;
            explicit data(const Uvr::UserId_t &userId,
                          const Uvr::OperatorId_t idSrc,
                          const Uvr::OctetStringPtr &callingNumber,
                          const Uvr::OctetStringPtr &calledNumber,
                          const Uvr::OctetStringPtr &originalCalledNumber,
                          const Uvr::OctetStringPtr &genericNumber,
                          const Uvr::CallId_t callId)
                : userId(userId),
                  idSrc(idSrc),
                  callingNumber(callingNumber),
                  calledNumber(calledNumber),
                  originalCalledNumber(originalCalledNumber),
                  genericNumber(genericNumber),
                  callId(callId)
            {
            }
        };

    }

} // namespace vfc
