#pragma once

#include <openssl/evp.h>
#include <ostream>

#include <components/tools/src/Tools.hpp>

struct md
{
    unsigned char *m_value{nullptr};
    const unsigned int m_len;

    explicit md(unsigned int len);
    ~md();

    std::string do_base64();
    std::string do_text() const;
    bool operator==(const md &other) const;
};

using md_p = std::shared_ptr<md>;

class hasher_t
{
public:
    hasher_t() = default;
    std::string do_hash_base64(const std::string &data);
    template <int a>
    md_p do_hash(const std::string &data);
};

md_p undo_base64(const std::string &md_base64);

inline std::string do_salt(const std::string &numA,
                           const std::string &numB,
                           const std::string &salt)
{
    return (numA + salt + numB + salt);
}
