#pragma once

// AFAP includes.
#include "components/http/src/connection.hpp"
#include "components/worker_node/src/typeInst.hpp"

namespace http
{
    class listener : public interfaces::connections::notifier::client
    {
    public:
        listener(const TypeInst &owner, boost::asio::io_context &ioc);
        void start(const std::string &port);
        void stop(void);

    protected:
        void prepareAcceptor(const std::string &port);
        void startAccept(void);
        void onAccept(const boost::system::error_code &err,
                      tcp::socket sock);

        const TypeInst &m_owner;                             ///< Own instance type
        boost::asio::io_context &m_ioc;                      ///< The io_context used to perform asynchronous operations.
        tcp::acceptor m_acceptor;                            ///< Acceptor for incoming connections
        connection_ptr<role::SERVER> m_nextConnPtr{nullptr}; ///< Pointer to next connection instance
        mutable std::recursive_mutex m_guard;                ///< Protector of shared data in multiple threads
        bool m_stopped{false};                               ///< Indicator whether server should stop listen to new connections
    };

} // namespace http
