#pragma once

// Log includes.
#include "Logger.hpp"

// STL includes.
#include <iostream>

namespace Log
{
    class CerrLogger : public Logger
    {
    public:
        CerrLogger() = default;
        ~CerrLogger() override;

    private:
        void processMessage(std::string &&message) override;
    };
} // namespace Log

//------------------------------------------------------------------------------
// Definitions
//------------------------------------------------------------------------------

namespace Log
{
    inline CerrLogger::~CerrLogger()
    {
        std::cerr << std::flush;
    }

    inline void CerrLogger::processMessage(std::string &&message)
    {
        std::cerr << message + '\n';
    }
} // namespace Log
