#pragma once

// Log includes.
#include "Tag.hpp"
#include "Time.hpp"
#include "Level.hpp"
#include "SourceLocation.hpp"

// STL includes.
#include <string>
#include <thread>

namespace Log
{
    struct Message final
    {
        Message(const Level level);

        Time time = Clock::now();
        std::thread::id threadId;
        Level level = Level::Trace;
        SourceLocation sourceLocation;
        Tag tag;
        std::string text = "";
    };
} // namespace Log

//------------------------------------------------------------------------------
// Definitions
//------------------------------------------------------------------------------

namespace Log
{
    inline Message::Message(const Level level)
        : level(level)
    {
    }
} // namespace Log
