#pragma once

// AFAP includes.
#include "components/worker_node/src/typeInst.hpp"

// Boost includes.
#include <boost/asio.hpp>
#include <boost/function.hpp>

// STL includes.
#include <memory>
#include <mutex>

class sequencer : public std::enable_shared_from_this<sequencer>
{
    static int id_cntr;
    static int number_of_ongoing_sequences;
    static std::recursive_mutex m_guard;

    std::string m_name;
    const TypeInst &m_owner;
    boost::asio::io_context *m_ioc_p;
    int m_id;
    unsigned int m_step{0};
    std::vector<std::function<bool(void)>> m_funcs;

public:
    sequencer(const std::string &name,
              const TypeInst &owner,
              boost::asio::io_context *ioc_p);
    virtual ~sequencer();

    void addFunction(std::function<bool(void)> const &func);
    void start();

    static int get_number_of_ongoing_sequences();

protected:
    void do_next_step();
};
