#pragma once

#include "worker_node/src/typeInst.hpp"
#include "common/src/pm_types.hpp"
#include "worker_node/src/transaction_manager.hpp"
#include "worker_node/src/primitive.hpp"
#include "pm/common/src/pm_primitive.hpp"

namespace oam
{
    enum class OutputFormat
    {
        Text,
        Json
    };

    namespace pm
    {
        namespace transaction
        {
            class data : public ::transaction::base_data
            {
            public:
                mutable std::recursive_mutex m_guard;
                int m_numOfWaitProviders{};
                primitive::generic::HeaderPtr m_header;
                ::pm::counter::container m_accum_storage;
                OutputFormat m_outputFormat;

                data() = default;
                ~data() override = default;
                data(const primitive::generic::HeaderPtr &header,
                     int numOfWaitProviders,
                     oam::OutputFormat outputFormat);
                data(const data &d);
                data &operator=(const data &d);
            };

            using manager = ::transaction::manager<data>;
        }
    }
}
