#pragma once

// AFAP includes.
#include "components/worker_node/src/sender.hpp"
#include "pm/provider/src/interfaces.hpp"

namespace pm
{
    class provider : public pm::interfaces::provider::server,
                     public workers::interfaces::sender::client
    {
        mutable std::recursive_mutex m_guard;

    protected:
        counter::container m_counters;

    public:
        ~provider() override;

    protected:
        provider();
        void registerCounters() override;
        void addCounter(counter::id counter, counter::indexing isIndexing) override;
        void addCounter(counter::id key, counter::index index) override;
        void increaseCounter(counter::id counter,
                             counter::value delta = counter::value(1)) override;

        void increaseCounter(counter::id counter,
                             counter::index index,
                             counter::value delta = counter::value(1)) override;

        void resetCounterNoIndex(counter::id counter) override;
        void resetCounter(counter::id counter, const counter::index &index) override;
        void setCounter(counter::id counter, counter::value value) override;
        void setCounter(counter::id counter, counter::index index, counter::value value) override;
        void handleGetCountersReq(const ::primitive::GenericPtr &prim) override;
    };

} // namespace pm
