#pragma once

// STL includes.
#include <string>

#define TAG(t) "\\\"" #t "\\\""
#define VAL(s) "\\\"" + s + "\\\""

#define STR(...) std::string(__VA_ARGS__)

#define SPACE0(A) STR(A)
#define SPACE(N, A) STR(A) + " " +
#define _CMDARG(N, ...) CAT(FOREACH, N)(N, SPACE, __VA_ARGS__)
#define CMDARG(...) _CMDARG(NARG(__VA_ARGS__), __VA_ARGS__)

namespace Cli
{
    namespace Cmd
    {
        const std::string printCounters = "print-counters";
        const std::string updateRecords = "update-records";
    }
}

#define CLI_CMD_EXEC(CLI_BIN, CLIGW_IP, CLIGW_PORT, CMD_ID, ...)      \
    std::string() + CLI_BIN + " " + CLIGW_IP + " " + CLIGW_PORT + " " \
                  + CMD_ID + " " + CMDARG(__VA_ARGS__)

#define CLI_CMD_PRINT_COUNTERS(CLI_BIN, CLIGW_IP, CLIGW_PORT, OUTPUT_FORMAT, RESET, COUNTERS) \
    CLI_CMD_EXEC(CLI_BIN, CLIGW_IP, CLIGW_PORT, Cli::Cmd::printCounters, OUTPUT_FORMAT) + " " \
    + "\"{" TAG(r) ":" + RESET + "," TAG(c) ":[" + COUNTERS + "]}\" "                         \
    + "2> /dev/null | awk -F'|' '{print $3}'"

#define CLI_CMD_UPDATE_RECORDS(CLI_BIN, CLIGW_IP, CLIGW_PORT, ...)                          \
    CLI_CMD_EXEC(CLI_BIN, CLIGW_IP, CLIGW_PORT, Cli::Cmd::updateRecords, __VA_ARGS__) + " " \
    + "2> /dev/null | awk -F'|' '{print $3}'"
