// Cli includes.
#include "ArgsParser.hpp"
#include "Cli.hpp"
#include "ReturnCode.hpp"

int main(int argC, char **argV)
{
    Cli::ArgsParser argsParser(argC, argV);

    if (!argsParser.isOk())
    {
        Cli::printShortHelp();
        return Cli::ReturnCode::ArgsParserFailed;
    }

    if (argsParser.isToPrintHelp())
    {
        Cli::printLongHelp();
        return Cli::ReturnCode::OK;
    }

    if (!Cli::connectToUvr(argsParser.getUvrAddress(), argsParser.getUvrPort()))
    {
        return Cli::ReturnCode::ConnectToUvrFailed;
    }

    if (!Cli::sendExecCmdReq(argsParser.getCmd(), argsParser.getCmdArgs()))
    {
        return Cli::ReturnCode::SendCmdRequestFailed;
    }

    if (!Cli::handleExecCmdRsp())
    {
        return Cli::ReturnCode::HandleCmdResponseFailed;
    }

    return Cli::ReturnCode::OK;
}
