#pragma once

#include "components/timers/src/timer_types.hpp"
#include "UvrTypes.hpp"

#define CONFIG_VFS "/vfs"
#define CONFIG_VFS_CALL_REGISTRY CONFIG_VFS "/call registry"

namespace vfs
{
    namespace config
    {

        constexpr auto callRegistryTTL = CONFIG_VFS_CALL_REGISTRY "/TTL/period";
        const auto callRegistryTTLDefaultValue = timers::Duration(std::chrono::milliseconds(60000));

        constexpr auto callRegistrySearchTimeout = CONFIG_VFS_CALL_REGISTRY "/searchTimeout/period";
        const auto callRegistrySearchTimeoutDefaultValue = timers::Duration(std::chrono::milliseconds(400));

    } // namespace config

} // namespace vfs
